
// File: SYN.H

// Header file for BCPL compiler - phase 1 - syntax routines

// Copyright (C) R.D. Eager   October 1989


GET "COM.H"

MANIFEST $(   // Operators and symbols
s.be                =  89
s.end               =  90
s.lsect             =  91
s.rsect             =  92
s.get               =  93
s.semicolon         =  97
s.into              =  98
s.to                =  99
s.by                = 100
s.do                = 101
s.or                = 102
s.vec               = 103
s.lparen            = 105
s.rparen            = 106
$)

MANIFEST $(   // Parameter values for 'advise'
adv_treesize        = 0   // Tree size value
adv_freespace       = 1   // Free space value
$)

GLOBAL $(   // Globals for SYN module
advise              : sg+000
ch                  : sg+001
chbuf               : sg+002
chcount             : sg+003
check_for           : sg+004
comp                : sg+005
declsyswords        : sg+006
decval              : sg+007
domapstore_         : sg+008
enablecode_         : sg+009
finished_           : sg+010
form_tree           : sg+011
getp                : sg+012
gett                : sg+013
getv                : sg+014
ignore              : sg+015
linecount           : sg+016
list1               : sg+017
list3               : sg+018
list4               : sg+019
list5               : sg+020
list6               : sg+021
lookupword          : sg+022
makelist            : sg+023
nametable           : sg+024
newvec              : sg+025
nextsymb            : sg+026
nlpending_          : sg+027
noget_              : sg+028
nulltag             : sg+029
pop_get             : sg+030
ppdebug_            : sg+031
pptrace_            : sg+032
prline              : sg+033
prsource_           : sg+034
push_get            : sg+035
rbexp               : sg+036
rch                 : sg+037
rcom                : sg+038
read_block_body     : sg+039
rdcdefs             : sg+040
rdef                : sg+041
read_section        : sg+042
read_sequence       : sg+043
read_tag            : sg+044
rec_l               : sg+045
rec_p               : sg+046
rexp                : sg+047
rexplist            : sg+048
read_name           : sg+049
read_namelist       : sg+050
rnexp               : sg+051
symb                : sg+052
syn_report          : sg+053
syntax_errors_      : sg+054
total_reports       : sg+055
treelist_           : sg+056
treep               : sg+057
treeq               : sg+058
treevec             : sg+059
wordnode            : sg+060
wordsize            : sg+061
wordv               : sg+062
wrchbuf             : sg+063
$)

MANIFEST $(   // Tunable MANIFESTs
chbufsize           =  64   // Size of circular character input trace buffer (powers of two only)
getitemsize         =   3   // Size of item stacked for each GET
getsize             =   4   // Number of GET files which may be open at once
maxcaset            = 5000  // Maximum value for K flag
maxdvect            = 20000 // Maximum value for D flag
maxglobdeclt        = 5000  // Maximum value for G flag
maxreportmax        = 500   // Maximum value for A flag
maxreports          =  20   // Default for number of errors before compilation is abandoned
maxtreesize         = 30000 // Maximum value for L flag
nametablesize       = 113   // Number of hash chains in name table
plist_names_        = TRUE  // Controls use of symbols in 'plist'
$)

// End of file: SYN.H


